<!DOCTYPE html>
<html lang="ja">
<head>
    <meta charset="UTF-8">
    <title>Vue3でAxiosを使って情報取得</title>
</head>

<body>
    <div id="app">
        <h1>[[ message ]]</h1>
            <input v-model="runquery" placeholder="Tpye your hostname."/>
            [[ query ]]
            <table border="1" style="border-collapse: collapse">
                    <tr><th>time</th><th>hostname</td><td>cpu</td><td>mem</td></tr>
                    <tr v-for="u in usage['data']" >
                        <td>[[ u.time]]</td>
                        <td>[[ u.hostname ]]</td>
                        <td>[[ u.cpu ]]</td>
                        <td>[[ u.mem ]]</td>
                    <tr>
            </table>
    </div>

    <!--<script src="https://unpkg.com/vue@next"></script>-->
    <script src="https://unpkg.com/vue@3/dist/vue.global.prod.js"></script>
    <script src="https://unpkg.com/axios/dist/axios.min.js"></script>

    <script>
        Vue.createApp({
            el: '#app',
            data(){
                return {
                    message: 'CPU/MEM Data',
                    usage: [],
                    query: '',
                    intervalId: null
                }
            },
            delimiters: ['[[', ']]'],
            computed:{
                runquery:{
                    get(){
                        return this.query
                    },
                    set(value){
                        this.query = value
                        this.get_query()
                    }
                }
            },
            methods: {
                get_query(){
                    if(this.query === ''){
                        axios
                            //.get('http://w10119316n.directri.local:5000/usage')
                            .get(location.protocol + '//' + document.domain + ':' + location.port + '/usage')
                            .then(response => (this.usage = response))
                    }else{
                        axios
                            //.get('http://w10119316n.directri.local:5000/usage/' + this.query)
                            .get(location.protocol + '//' + document.domain + ':' + location.port + '/usage/' + this.query)
                            .then(response => (this.usage = response))
                    }
                return
                },
            }, 
            mounted(){
                this.intervalId = setInterval(() => {
                    this.get_query();
                    console.log('executed this.get_query')
                }, 1000)
                    
                },
                beforeDestroy () {
                    console.log('clearInterval')
                    clearInterval(this.intervalId)
                }
            }
        ).mount('#app')
    </script>
</body>
</html>